/* $Id: symbol.c,v 1.1 1996/11/07 08:04:02 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	V{l[ǗW[
 *	Copyright (C) 1989,1990 K.Abe
 *	All rights reserved.
 *	Copyright (C) 1997,1998 Tachibana Eriko.
 *
 */

#include	<stdio.h>
#include	<string.h>

#include	"estruct.h"
#include	"etc.h"
#include	"global.h"
#include	"hex.h"		/* itoxd() */
#include	"label.h"
#include	"output.h"	/* outputf() */
#include	"symbol.h"


USEOPTION	option_g;
short	Output_Symbol = 1;	/* 0:Ȃ 1:萔̂ 2:.xdef  */


#ifdef	STATIC_SYM_BUF
int	Symbolbufsize = 2048;
#else
static int	Symbolbufsize;		/* V{obt@̐ */
#define	SYM_BUF_UNIT	16		/* obt@g厞̑vf */
#endif
static symbol*	Symtable;		/* V{e[u̓ */
static int	Symnum;			/* V{e[u̗vf */

#ifdef	STATIC_CONST_SYM_BUF
static const_symbol* ConstSymtable;	/* V{e[u̓ */
static int	     ConstSymnum;	/* V{e[u̗vf */
#endif


extern void	init_symtable( void )
{
#ifdef	STATIC_SYM_BUF
    Symtable = Malloc (Symbolbufsize * sizeof (symbol));
#endif

#ifdef	STATIC_CONST_SYM_BUF
    ConstSymtable = Malloc (Symbolbufsize * sizeof (const_symbol));
#endif
}


#ifndef	OSKDIS
/*
	st@CɕtV{e[uo^
	xt@C̓ǂݍ݂ɌĂяo
*/
extern void
make_symtable (void)
{
    char* ptr = (char*)(Top + Head.text + Head.data + Head.offset);
    ULONG end = (ULONG)ptr + Head.symbol
	      - (sizeof (UWORD) + sizeof (address) + 2);

    if ((int)ptr & 1)
	return;

    while ((ULONG)ptr <= end) {
	int	type = *((UWORD*)ptr)++;
	address adrs = *((address*)ptr)++;

	if (!*ptr)
	    continue;

	switch (type) {
	case XDEF_ABS:
#ifdef	STATIC_CONST_SYM_BUF
	    add_constsymbol (adrs, ptr);
#endif
	    break;

	case XDEF_COMMON:
	case XDEF_TEXT:
	case XDEF_DATA:
	case XDEF_BSS:
	case XDEF_STACK:
	    {
		symbol* sym = symbol_search (adrs);

		if (sym && sym->type)
		    ;	/* ɃV{񂪂΃xo^Ȃ */
		else
		    regist_label (adrs, DATLABEL | UNKNOWN | SYMLABEL);

		/* -g w莞̓V{e[uo^Ȃ */
		/* A͗p		     */
		if (!option_g)
		    add_symbol (adrs, type, ptr);
		else if (sym)
		    sym->type = type;		/* O`V{Ɋiグ */

	    }
	    break;

	default:
	    eprintf ("Ή̃V{ł(%#.6x %#.6x %s)\n",
						type, adrs, ptr);
	    break;

	}
	/* V{΂ */
	while (*ptr++)
	    ;
	ptr += (int)ptr & 1;
    }
}
#endif	/* !OSKDIS */


/*

  n

  V{XgƃV{obt@Kv邯ǎ蔲.

*/
extern void
free_symbuf (void)
{
    Mfree (Symtable);

#ifdef	STATIC_CONST_SYM_BUF
    Mfree (ConstSymtable);
#endif
}


/*

  adrs V{e[u{
  adrs  common text data bss ̂ꂩ
  |C^AłȂ NULL Ԃ

*/
extern symbol	*symbol_search( address adrs )
{
    int step;
    symbol* ptr;

    /* ͑Ȃ? */
    if (Symnum == 0)
	return NULL;

    ptr = Symtable;
    for (step = Symnum >> 1; step > 4; step >>= 1)
	if ((ptr + step)->adrs <= adrs)		/* binary search */
	    ptr += step;

    for (; ptr < Symtable + Symnum; ptr++) {
	if (ptr->adrs == adrs)
	    return ptr;
	else
	    if (adrs < ptr->adrs)
		return NULL;
    }
    return NULL;
}


extern void	add_symbol( address adrs , int type , char *symstr )
{					    /* type == 0 : labelfileł̒` */
    int  i;
    symbol *sym;

    /* ɓo^ς݂Ȃ瑮ύXV{̒ǉ */
    if( ( sym = symbol_search( adrs ) ) != NULL ) {
	symlist *ptr = sym->next;
	sym->type = type;

	if( ptr == NULL )
	    ptr = sym->next = Malloc( sizeof(symlist) );
	else {
	    while( ptr->next )
		ptr = ptr->next;
	    ptr = ptr->next = Malloc( sizeof(symlist) );
	}
	ptr->next = NULL;
	ptr->sym = symstr;
	return;
    }

#ifdef	STATIC_SYM_BUF
    if (Symnum == Symbolbufsize)
	err ("V{e[uӂ܂.\n");
#else
    if (Symnum == Symbolbufsize) {
	/* obt@g傷 */
	Symbolbufsize += SYM_BUF_UNIT;
	Symtable = Realloc (Symtable, Symbolbufsize * sizeof (symbol));
    }
#endif

    for( i = Symnum - 1 ; (i >= 0) && (Symtable[ i ].adrs > adrs) ; i-- )
	Symtable[ i + 1 ] = Symtable[ i ];

#if 0
    if( (i >= 0) && (Symtable[ i ].adrs == adrs) )
	return;
#endif

    i++;
    Symtable[ i ].adrs = adrs;
    Symtable[ i ].type = (UWORD)type;
    Symtable[ i ].next = NULL;
    Symtable[ i ].sym  = symstr;
    Symnum++;

#ifdef	DEBUG
    printf( "type %4x adrs %6x sym:%s\n" , Symtable[ i ].type ,
	   Symtable[ i ].adrs , Symtable[ i ].sym );
#endif
}


extern boolean
is_exist_symbol (void)
{
    return Symnum ? TRUE : FALSE;
}


#ifndef	OSKDIS
/*
	\[XR[hɃV{`o͂

	:
		op_equ	.equ ^("\t.equ\t")
		colon	R("::" -C IvVɂĕύX)
	Ԓl
		o͂V{(s)
*/
extern int
output_symbol_table (const char* op_equ, const char* op_xdef, const char* colon)
{
    char* ptr = (char*)(Top + Head.text + Head.data + Head.offset);
    ULONG end = (ULONG)ptr + Head.symbol
	      - (sizeof (UWORD) + sizeof (address) + 2);
    int out_xdef = (Output_Symbol == 2);
    int count = 0;

    if ((int)ptr & 1 || !Output_Symbol)
	return count;

    while ((ULONG)ptr <= end) {
	int	type = *((UWORD*)ptr)++;
	address adrs = *((address*)ptr)++;

	if (!*ptr)
	    continue;

	switch (type) {
	case XDEF_ABS:
	    {
		char* tab = (strlen (ptr) < (8-2)) ? "\t" : "";  /* TAB-2 */
		char buf[16];

		/* uxxx:: .equ $nnv̌`ŏo͂ */
		itoxd (buf, (ULONG)adrs, 8);
		outputf ("%s%s%s%s%s" CR, ptr, colon, tab, op_equ, buf);
		count++;
	    }
	    break;

	case XDEF_COMMON:
	case XDEF_TEXT:
	case XDEF_DATA:
	case XDEF_BSS:
	case XDEF_STACK:
	    if (out_xdef) {
		outputf ("%s%s" CR, op_xdef, ptr);
		count++;
	    }
	    break;

	case 0:		/* xt@CŒ`ꂽV{ */
	default:
	    break;

	}
	/* V{΂ */
	while (*ptr++)
	    ;
	ptr += (int)ptr & 1;
    }

    return count;
}
#endif	/* !OSKDIS */


/* ȉ͖gp֐ */

#if 0
extern void	del_symbol( address adrs )
{
    symbol *sym;

    if( ( sym = symbol_search( adrs ) ) != NULL ) {
	symlist *ptr = sym->next;
	while( ptr ) {
	    symlist *next = ptr->next;
	    Mfree( ptr );
	    ptr = next;
	}

	Symnum--;
	for( ; sym < &Symtable[ Symnum ] ; sym++ )
	    *sym = *(sym + 1);
    }
}
#endif

#ifdef	STATIC_CONST_SYM_BUF
extern void	add_constsymbol( address adrs , char *symstr )
{
    if (ConstSymnum == Symbolbufsize)
	err ("V{e[uӂ܂\n");

    ConstSymtable[ ConstSymnum ].adrs = adrs;
    ConstSymtable[ ConstSymnum ].sym  = symstr;
    ConstSymnum++;
}

extern int  get_constsymbol_num( void )
{
    return ConstSymnum;
}

extern const_symbol *get_constsymbol( int i )
{
    return ConstSymtable + i;
}
#endif

/* EOF */
